unit F_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, JPEG, gifimage, Buttons, clipbrd, Spin, ToolWin, 
  ExtCtrls, Menus, ComCtrls, iniFiles, shellApi, ExtDlgs,

  U_Cocktail, U_CocktailConst, {specif unit}
  C_Cocktail, {specif classes}
  D_Cocktail, {datamodule}
  F_Splash, F_DialogColor, {form}
  u_help,{generic unit}
  T_NavigatorComboBox, U_FlatButton { My Component };
type
  TEditState = (editAjout, editModif, editNoEdit);
type
  TFMain = class(TForm)
    MainMenu: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    PanelRecette: TPanel;
    StatusBar: TStatusBar;
    ToolBar: TToolBar;
    eCocktailName: TEdit;
    bChangeCocktail: TBitBtn;
    bAddCocktail: TBitBtn;
    bSupprCocktail: TBitBtn;
    bOk: TBitBtn;
    gbMelangeur: TGroupBox;
    cbMelangeur: TComboBox;
    gbVerre: TGroupBox;
    cbVerre: TComboBox;
    ImageVerre: TImage;
    gbCout: TGroupBox;
    cbCout: TComboBox;
    gbCaracteristique: TGroupBox;
    Label1: TLabel;
    seNbPers: TSpinEdit;
    Label2: TLabel;
    cbAlcool: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    cbTemperature: TComboBox;
    GroupBox5: TGroupBox;
    PanelCouleur: TPanel;
    ImageCocktail: TImage;
    bFichierImage: TBitBtn;
    odImageCocktail: TOpenPictureDialog;
    gbIngredients: TGroupBox;
    mIngredients: TMemo;
    gbRecette: TGroupBox;
    mRecette: TMemo;
    ToolButton1: TToolButton;
    sbCocktail: TScrollBar;
    PanelNumeroCocktail: TPanel;
    bCancel: TBitBtn;
    bEffacer: TBitBtn;
    cbBulle: TCheckBox;
    sdCocktail: TSaveDialog;
    Enregistrerlalistesous1: TMenuItem;
    Ouvriruneliste1: TMenuItem;
    odCocktail: TOpenDialog;
    bSearch: TBitBtn;
    N1: TMenuItem;
    Exporterlarecette1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Imprimer1: TMenuItem;
    sdExport: TSaveDialog;
    Aide1: TMenuItem;
    Aide2: TMenuItem;
    N4: TMenuItem;
    AProposde1: TMenuItem;
    Nouvelleliste1: TMenuItem;
    Outils1: TMenuItem;
    BitBtn1: TBitBtn;
    PanelHideMelangeur: TPanel;
    Bevel1: TBevel;
    PanelHideAlcool: TPanel;
    Bevel2: TBevel;
    PanelHideTemperature: TPanel;
    Bevel3: TBevel;
    PanelHideCout: TPanel;
    Bevel4: TBevel;
    PanelHideVerre: TPanel;
    Bevel5: TBevel;
    Mlangerdeuxliste1: TMenuItem;
    Nettoyeruneliste1: TMenuItem;
    ImageMelangeur: TImage;
    Association1: TMenuItem;
    Edition1: TMenuItem;
    Copierrecettedanslepressepapier1: TMenuItem;
    Exportertouteslesrecettes1: TMenuItem;
    Enregistrerlaliste1: TMenuItem;
    cbCocktailName: TNavigatorComboBox;
    Copierlaphotodanslepressepapier1: TMenuItem;
    FormatText1: TMenuItem;
    FormatHTML1: TMenuItem;
    FormatRTF1: TMenuItem;
    MisejoursurleWeb1: TMenuItem;
    N5: TMenuItem;
    procedure Quitter1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbMelangeurChange(Sender: TObject);
    procedure cbVerreChange(Sender: TObject);
    procedure PanelCouleurMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PanelCouleurMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PanelCouleurClick(Sender: TObject);
    procedure bFichierImageClick(Sender: TObject);
    procedure bChangeCocktailClick(Sender: TObject);
    procedure bAddCocktailClick(Sender: TObject);
    procedure bEffacerClick(Sender: TObject);
    procedure bCancelClick(Sender: TObject);
    procedure bOkClick(Sender: TObject);
    procedure sbCocktailChange(Sender: TObject);
    procedure Enregistrerlalistesous1Click(Sender: TObject);
    procedure Ouvriruneliste1Click(Sender: TObject);
    procedure bSupprCocktailClick(Sender: TObject);
    procedure bSearchClick(Sender: TObject);
    procedure Exporterlarecette1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure cbCocktailNameClick(Sender: TObject);
    procedure AProposde1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Nouvelleliste1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Mlangerdeuxliste1Click(Sender: TObject);
    procedure Nettoyeruneliste1Click(Sender: TObject);
    procedure cbMelangeurDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure Association1Click(Sender: TObject);
    procedure Copierrecettedanslepressepapier1Click(Sender: TObject);
    procedure Enregistrerlaliste1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Aide2Click(Sender: TObject);
    procedure cbCocktailNameKeyPress(Sender: TObject; var Key: Char);
    procedure cbCocktailName_OnItemMatch(Sender: TObject;
      ItemIndex: Integer);
    procedure Copierlaphotodanslepressepapier1Click(Sender: TObject);
    procedure cbCocktailNameDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormatText1Click(Sender: TObject);
    procedure AidesurleWeb1Click(Sender: TObject);
    procedure MisejoursurleWeb1Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure AddDrawableItem(cb : TComboBox ; itemsstring : string ; bitmap : TBitmap);

  public
    { Dclarations publiques }
    ListCocktail : TListCocktail;
    index        : integer; // index en cours dans la liste des cocktail
    EtatEdition  : TEditState;
    OldCockNum   : integer;
    Modified     : boolean; // mis a true si une modif a eu lieu pour prevenir avant de quitter
    procedure InitApplication;
    procedure DeInitApplication;
    procedure InitListMelangeur;
    procedure InitListVerre;
    procedure InitAutreListe;

    procedure AffInfo(const str : string ; NumElem : integer);
    procedure AffInfoBar(const str : string);
    procedure AffAlertWindow(const str : string);

    procedure PossibiliterEdition(etat : boolean);
    procedure EnableToolBar(etat : boolean);
    procedure ShowCocktailInfo(cock : TCocktailRecette ; idx : integer);
    function  CheckCocktailValue : boolean;
    function  LoadCocktailPhoto(filename : string ; img : TImage) : string;
    procedure LoadCocktailList;
    procedure PutCocktailInCombo;
    procedure OnAppException(Sender: TObject; E: Exception);
  end;

var
  FMain: TFMain;

implementation

uses
     U_FuncDialog,
     U_FuncString,
     U_FuncFile,
     U_FuncDebug,
     F_CocktailSearch,
     F_Print,
     F_About,
     F_Tools,
     F_ShowPicture,
     F_Proportion;

{$R *.DFM}

procedure TFMain.AddDrawableItem(cb : TComboBox ; itemsstring : string ; bitmap : TBitmap);
begin
  cb.Items.AddObject(itemsstring, TOBject(Bitmap));
end;

procedure TFMain.Quitter1Click(Sender: TObject);
var
  res : integer;
begin
  if (Modified) then
  begin
    res := Application.MessageBox(PCHAR(DIALOG_SAVE_BEFORE_QUIT),
                           APP_NAME,
                           MB_YESNOCANCEL);
    case res of
      IDYES : begin
                Enregistrerlaliste1Click(self);
                if (Modified = False) then
                  Close;
              end;
      IDNO  : Close;
      IDCANCEL:
    end;

  end
  else
    Close;
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
  InitApplication;
  Application.OnException := OnAppException;
  Modified := false;
end;

procedure TFMain.InitApplication;
begin
  FSplash := TFSplash.Create(self);
  FSplash.Show;
  FSplash.Refresh;
    ListCocktail := TListCocktail.Create;
    ListCocktail.Sorted := true;
    ListCocktail.OnShowInfo := AffInfo;
    LoadCocktailList;
    PutCocktailInCombo;
    Show;
    DCocktail := TDCocktail.Create(self);
    FDialogColor := TFDialogColor.Create(Self);
    InitListMelangeur;
    InitListVerre;
    InitAutreListe;
    EtatEdition := editNoEdit;
    PossibiliterEdition(false);
    index := 0;
    sbCocktail.Min := 0;
    sbCocktail.Max := ListCocktail.Count ;
    sbCocktailChange(nil);
  FSplash.Close;
  FSplash.Free;
  FSplash := nil;
  sbCocktail.SetFocus;
end;

procedure TFMain.FormDestroy(Sender: TObject);
begin
  DeInitApplication;
end;

procedure TFMain.DeInitApplication;
var
  i : integer;
begin
  ListCocktail.Free;
  DCocktail.Free;
  FDialogColor.Free;
  cbCocktailName.Clear;
  for i := 0 to cbMelangeur.Items.Count - 1 do
  begin
    TBitmap(cbMelangeur.Items.Objects[i]).Free;
    cbMelangeur.Items.Objects[i] := nil;
  end;
  for i := 0 to cbVerre.Items.Count - 1 do
  begin
      TBitmap(cbVerre.Items.Objects[i]).Free;
    cbVerre.Items.Objects[i] := nil;
  end;
end;

procedure TFMain.InitListMelangeur;
var
  i : integer;
  bmp : TBitmap;
begin
{  cbMelangeur.Clear;
  for i := 0 to integer(melAutre) do
  begin
    cbMelangeur.Items.Add(CocktailMelangeur2Str(TCocktailMelangeur(i)));
  end;}
  cbMelangeur.Clear;
  for i := 0 to integer(melAutre) do
  begin
//    cbMelangeur.Items.Add(CocktailMelangeur2Str(TCocktailMelangeur(i)));
    bmp := TBitmap.Create;
    DCocktail.MelangeurImageList.GetBitmap(i, bmp);
    AddDrawableItem(cbMelangeur,
                    CocktailMelangeur2Str(TCocktailMelangeur(i)),
                    bmp);
  end;

end;

procedure TFMain.InitListVerre;
var
  i : integer;
  bmp : TBitmap;
begin
  cbVerre.Clear;
  for i := 0 to integer(verreAutre) do
  begin
    bmp := TBitmap.Create;
    DCocktail.VerreImageList.GetBitmap(i, bmp);
    AddDrawableItem(cbverre,
                    CocktailVerre2Str(TCocktailVerre(i)),
                    bmp);
//    cbVerre.Items.Add(CocktailVerre2Str(TCocktailVerre(i)));
  end;
  cbVerre.DropDownCount := cbVerre.Items.Count;
end;

procedure TFMain.InitAutreListe;
var
  i : integer;
begin
  cbCout.Clear;
  for i := 0 to integer(coutCher) do
  begin
    cbCout.Items.Add(CocktailCout2str(TCocktailCout(i)));
  end;
  cbAlcool.Clear;
  for i := 0 to integer(alcoolAie) do
  begin
    cbAlcool.Items.Add(CocktailAlcool2str(TCocktailAlcool(i)));
  end;
  cbTemperature.Clear;
  for i := 0 to integer(tempBrulant) do
  begin
    cbTemperature.Items.add(CocktailTemperature2str(TCocktailTemperature(i)));
  end;
  ImageCocktail.Visible := false;
end;

procedure TFMain.cbMelangeurChange(Sender: TObject);
var
  i : integer;
begin
  i := cbMelangeur.ItemIndex;
  if (i <> -1) then
  begin
    DCocktail.SetMelangeurImageForImage(TCocktailMelangeur(i), ImageMelangeur);
  end;
end;

procedure TFMain.cbVerreChange(Sender: TObject);
var
  i : integer;
begin
  i := cbVerre.ItemIndex;
  if (i <> -1) then
  begin
    DCocktail.SetVerreImageForImage(TCocktailVerre(i), ImageVerre);
  end;
end;

procedure TFMain.PanelCouleurMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  PanelCouleur.BevelInner := bvLowered;
  PanelCouleur.BevelOuter := bvNone;
end;

procedure TFMain.PanelCouleurMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  PanelCouleur.BevelInner := bvNone;
  PanelCouleur.BevelOuter := bvRaised;
end;

procedure TFMain.PanelCouleurClick(Sender: TObject);
begin
  if (EtatEdition = editNoEdit) then
  begin
    // Montrer l'image en grand
    if (PanelCouleur.Tag = -1) and (ListCocktail[index].Photo = '') then
      exit;
    FShowPicture := TFShowPicture.Create(self);
    FShowPicture.LoadPicture(ListCocktail[index].Photo);
    FShowPicture.Caption := ListCocktail[index].Nom;
    FShowPicture.ShowModal;
    FShowPicture.Free;
  end
  else
  begin
    // Changer la couleur
    FDIalogColor.CouleurChoisi := PanelCouleur.Tag;
    if (FDialogColor.Execute = true) then
    begin
      // Click sur OK
      ImageCocktail.Picture := FDialogColor.Verre.Picture;
      odImageCocktail.Filename := '';
      PanelCouleur.Tag := FDIalogColor.CouleurChoisi;
      ImageCocktail.Visible := true;
    end
    else
    begin
      // click sur Annuler ou Sans couleur
      if (FDIalogColor.CouleurChoisi = -1) then
      begin
        // sans couleur
        ImageCocktail.Visible := false;
        PanelCouleur.Tag := -1;
        odImageCocktail.FileName := '';
      end;
    end;
  end;
end;

procedure TFMain.bFichierImageClick(Sender: TObject);
begin
  try
    if (odImageCocktail.Execute = true) then
    begin
      ImageCocktail.Picture.LoadFromFile(odImageCocktail.Filename);
      ImageCocktail.Visible := true;
    end
  except
    odImageCocktail.Filename := '';
  end;
end;

procedure TFMain.PossibiliterEdition(etat : boolean);
begin
  bOk.Visible := etat;
  bCancel.Visible := etat;
  bEffacer.Visible := etat;
  eCocktailName.ReadOnly := not etat;
  cbCocktailName.Visible := not etat;
  mRecette.ReadOnly := not etat;
  mIngredients.ReadOnly := not etat;

  gbCaracteristique.Enabled := etat;
    PanelHideAlcool.Visible := not etat;
    PanelHideTemperature.Visible := not etat;

  gbCout.Enabled := etat;
    PanelHideCout.Visible := not etat;

  gbMelangeur.Enabled := etat;
    PanelHideMelangeur.Visible := not Etat;

  gbVerre.Enabled := etat;
    PanelHideVerre.Visible := not etat;

  bFichierImage.visible := etat;
  PanelCouleur.Enabled := etat;
end;

procedure TFMain.EnableToolBar(etat : boolean);
begin
  bAddCocktail.Enabled := etat;
  bSupprCocktail.Enabled := etat;
  bChangeCocktail.Enabled := etat;
  sbCocktail.Enabled := etat;
  bSearch.Enabled := etat;
  cbCocktailName.Enabled := etat;
end;

procedure TFMain.bChangeCocktailClick(Sender: TObject);
begin
  OldCockNum := sbCocktail.position;
  PossibiliterEdition(true);
  EnableToolBar(false);
  EtatEdition := editModif;
  Modified := true;
end;

procedure TFMain.bAddCocktailClick(Sender: TObject);
begin
  OldCockNum := sbCocktail.position;
  PossibiliterEdition(true);
  EnableToolBar(false);
  EtatEdition := editAjout;
  bEffacerClick(nil);
  eCocktailName.SetFocus;
  PanelNumeroCocktail.Caption := IntToStr(ListCocktail.Count+1);
end;

procedure TFMain.bEffacerClick(Sender: TObject);
begin

  eCocktailName.Text := '';
  cbMelangeur.ItemIndex := 0;
  cbCout.ItemIndex := 0;
  cbVerre.ItemIndex := 0;
  seNbPers.Value := 1;
  cbAlcool.ItemIndex := 1;
  cbTemperature.ItemIndex := 0;
  PanelCouleur.Tag := -1;
  ImageCocktail.Visible := false;
  mRecette.Clear;
  mIngredients.Clear;
  odImageCocktail.FileName := '';

  cbMelangeurChange(self);
  cbVerreChange(Self);
  eCocktailName.SetFocus;


end;

procedure TFMain.bCancelClick(Sender: TObject);
begin
  EtatEdition := editNoEdit;
  PossibiliterEdition(false);
  EnableToolBar(true);
  sbCocktail.Position := OldCockNum;
  sbCocktailChange(nil);
end;

procedure TFMain.bOkClick(Sender: TObject);
var
  LeCocktail : pTCocktailRecette;
  pos : integer;
begin
  Modified := true;
  if (CheckCocktailValue = true) then
  begin
    eCocktailName.Text := Trim(eCocktailName.Text);
    pos := ListCocktail.GetRecetteIdxByNom(eCocktailName.Text);
    if (pos <> -1) and (EtatEdition = editAjout) then
    begin
      // Doublons
      if (Application.MessageBox(PCHAR(Format(DIALOG_RECETTEALREADYEXIST_TEXT, [eCocktailName.Text])),
                                 PCHAR(DIALOG_RECETTEALREADYEXIST_TITLE),
                                 MB_YESNO) = IDNO)then
      begin
        exit;
      end;
    end;
    new (LeCocktail);
    FillChar(LeCocktail^, SizeOf(TCocktailRecette), 0);
    LeCocktail^.Alcool := TCocktailAlcool(cbAlcool.ItemIndex);
    LeCocktail^.Auteur := ''; // ToDo
    LeCocktail^.Bulle := cbBulle.Checked;
    LeCocktail^.Couleur1 := PanelCouleur.Tag;
    LeCocktail^.Couleur2 := -1; // ToDo
    LeCocktail^.Cout := TCocktailCout(cbCout.ItemIndex);
    LeCocktail^.Gout := TCocktailGout(2); // ToDo
    LeCocktail^.Id := 0; // ToDo
    LeCocktail^.Ingredients := mIngredients.Text;
    LeCocktail^.Melangeur := TCocktailMelangeur(cbMelangeur.ItemIndex);
    LeCocktail^.NbPersonne := seNbPers.Value;
    LeCocktail^.Nom := eCocktailName.Text;
    LeCocktail^.Photo := odImageCocktail.FileName;
    LeCocktail^.Recette := mRecette.Text;
    LeCocktail^.Temperature := TCocktailTemperature(cbTemperature.ItemIndex);
    LeCocktail^.Verre := TCocktailVerre(cbVerre.ItemIndex);
    LeCocktail^.Video := ''; // ToDo
    if (EtatEdition = editAjout) then
    begin
      pos := ListCocktail.AddRecette(LeCocktail);
      sbCocktail.Max := ListCocktail.Count - 1;
      sbCocktail.Position := pos;
      sbCocktailChange(nil);
      AffInfoBar(Format(INFO_ADD_COCK, [LeCocktail^.Nom]));
      OutputDebugFormat('"%s" ajout position %d sur %d recettes', [LeCocktail^.Nom, pos, ListCocktail.Count ]);
    end
    else
    if (EtatEdition = editModif) then
    begin
      pos := Index;
      if (LeCocktail^.Nom <> ListCocktail[pos].Nom) then
      begin // ToDo:L'utilisateur a chang le nom du cocktail
      end;
      ListCocktail.ReplaceRecette(pos, leCocktail);
      AffInfoBar(Format(INFO_CHANGE_COCK, [LeCocktail^.Nom]));
    end;
    EtatEdition := editNoEdit;
    PossibiliterEdition(false);
    EnableToolBar(true);
    PanelNumeroCocktail.Caption := IntToStr(index+1);
    PutCocktailInCombo;
  end
  else
  begin
    ShowMessage(DIALOG_ERR_INCORECT_VALUE);
  end;
  cbCocktailName.Text := eCocktailName.Text;
end;

procedure TFMain.sbCocktailChange(Sender: TObject);
begin
  index := sbCocktail.position;
  if (index > ListCocktail.Count - 1) then
  begin
    index := ListCocktail.Count - 1;
  end;
  if (ListCocktail.Count > 0) then
  begin
    bSupprCocktail.enabled := true;
    bChangeCocktail.Enabled := true;
    ShowCocktailInfo(ListCocktail[index], index);
    PanelNumeroCocktail.Caption := IntToStr(index+1);
  end
  else
  begin
    // Aucun cocktail
    bSupprCocktail.enabled := false;
    bChangeCocktail.Enabled := false;
    PanelNumeroCocktail.Caption := '';
  end;
end;

procedure TFMain.ShowCocktailInfo(cock : TCocktailRecette ; idx : integer);
var
  photo_path : string;
begin
  if (cock.photo <> '') then
  begin
    OutputDebug(cock.photo);
  end;
  cbAlcool.ItemIndex := Integer(cock.Alcool);
  cbBulle.Checked := cock.Bulle;
  PanelCouleur.Tag := cock.Couleur1;
  ImageCocktail.Visible := (Cock.Couleur1 <> -1) or (Cock.Photo <> '');
  PanelCouleur.Enabled := ImageCocktail.Visible;
  cbCout.ItemIndex := integer(cock.Cout);
  mIngredients.Text := cock.Ingredients;
  cbMelangeur.ItemIndex := integer(cock.Melangeur);
  seNbPers.Value := cock.NbPersonne;
  eCocktailName.Text := cock.Nom;
  cbCocktailName.Text := cock.Nom;
  mRecette.Text := cock.Recette;
  cbTemperature.ItemIndex := Integer(cock.Temperature);
  cbVerre.ItemIndex := Integer(cock.Verre);

  cbMelangeurChange(self);
  cbVerreChange(Self);
  if (cock.Couleur1 <> -1) then
  begin
    FDialogColor.DrawVerreNoDegrad(cock.Couleur1, ImageCocktail);
  end
  else
  if (cock.Photo <> '') then
  begin
    photo_path := LoadCocktailPhoto(cock.Photo, ImageCocktail);
    odImageCocktail.FileName := photo_path;
    if (photo_path <> cock.photo) and (photo_path <> '') then
    begin
      // une image a t dplac, mais on l'a retrouv.
      ListCocktail.ItemsPointer[idx]^.Photo := photo_path;
    end;
  end
  else
    odImageCocktail.FileName := '';

  if (mRecette.Lines.Count > 9) then
    mRecette.ScrollBars := ssVertical
  else
    mRecette.ScrollBars := ssNone;
  if (mIngredients.Lines.Count > 8) then
    mIngredients.ScrollBars := ssVertical
  else
    mIngredients.ScrollBars := ssNone;
end;

function  TFMain.CheckCocktailValue : boolean;
begin
  result := (eCocktailName.Text <> '') and
            (cbMelangeur.ItemIndex <> -1) and
            (cbVerre.ItemIndex <> -1) and
            (cbCout.ItemIndex <> -1) and
            (cbAlcool.ItemIndex <> -1) and
            (cbTemperature.ItemIndex <> -1);
end;

procedure TFMain.Enregistrerlalistesous1Click(Sender: TObject);
begin
  if (sdCocktail.Execute = true) then
  begin
    try
      Screen.Cursor := crHourGlass;
      if (sdCocktail.FilterIndex = 1) then // format standard : .CTL
      begin
        ListCocktail.SaveToFile(sdCocktail.FileName);
        AffInfo(INFO_END_OF_SAVE, 0);
        Modified := false;
      end
      else
      if (sdCocktail.FilterIndex = 2) then // format excel .txt
      begin
        ListCocktail.ExportAllRecette(sdCocktail.FileName);
        AffInfo(INFO_END_OF_EXPORT, 0);
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TFMain.Ouvriruneliste1Click(Sender: TObject);
begin
  if (EtatEdition = editModif ) or (EtatEdition = editAjout) then
  begin
      AffAlertWindow(INFO_WARN_OPEN_WHILE_EDIT);
      exit;
  end;

  if (odCocktail.Execute = true) then
  begin
    try
      Screen.Cursor := crHourGlass;
      sdCocktail.FileName := odCocktail.FileName;
      ListCocktail.DeleteAllRecette;
      ListCocktail.LoadFromFile(odCocktail.FileName);
      if (ListCocktail.Count > 0) then
        sbCocktail.Max := ListCocktail.Count - 1
      else
        sbCocktail.Max := 0;
      sbCocktail.Position := 0;
      sbCocktailChange(nil);
      EtatEdition := editNoEdit;
      PossibiliterEdition(false);
      AffInfo(INFO_END_OF_LOAD + Format(' (%d cocktails)', [ListCocktail.Count]), 0);
      sbCocktail.SetFocus;
      PutCocktailInCombo;
      cbCocktailName.ItemIndex := 0;
      Modified := false;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TFMain.bSupprCocktailClick(Sender: TObject);
var
  pos : integer;
begin
  if (Application.MessageBox(PCHAR(DIALOG_SUPPRES_TEXT),
                             PCHAR(DIALOG_SUPPRES_TITLE),
                             MB_YESNO) = IDYES	) then
  begin
    // Suppression
    pos := sbCocktail.Position;
    if (pos > ListCocktail.Count - 1) then // __JF v1.4 22/03/2001
      pos := ListCocktail.Count - 1;
    AffInfoBar(Format(INFO_DELETE_COCK, [ListCocktail[pos].Nom ]));
    ListCocktail.DelRecetteIdx(pos);
    sbCocktail.Max := ListCocktail.Count;
    PutCocktailInCombo;
    sbCocktailChange(nil);
  end;
end;

function TFMain.LoadCocktailPhoto(filename : string ; img : TImage) : string;
// Retourne le chemin + l'image
var
  ini : TIniFile;
  fname : string;
  path : string;
begin
  if (FileExists(FileName)) then
  begin
    img.Picture.LoadFromFile(FileName);
    result := FileName;
  end
  else
  begin
    ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
    path := ini.ReadString(INI_PATH_SECTION, INI_PATH_PHOTO, '');
    fname := FindFileInPath(filename, path, PathToExe+'\'+path, PathToExe);
    if (fname <> '') then
    begin
      img.Picture.LoadFromFile(fname);
      result := fname;
      OutputDebug('-->'+fname);
    end
    else
    begin
      AffInfoBar(Format(INFO_FILENOTFOUND, [FileName]));
      OutputDebug('!! Photo pas trouv !');
      result := '';
    end;
    {
    fname := ExtractOnlyFileName(Filename);
    FileName := PathToExe + '\' + path + '\' + fname;
    if (FileExists(FileName)) then
    begin
      img.Picture.LoadFromFile(FileName);
      result := FileName;
      OutputDebug('-->'+FileName);
    end
    else
    begin
      // Demander a l'operateur un chemin
      AffInfoBar(Format(INFO_FILENOTFOUND, [FileName]));
      OutputDebug('!! Photo pas trouv !');
      result := '';
    end;}
    ini.Free;
  end;

end;

procedure TFMain.AffInfo(const str : string; NumElem : integer);
begin
  if (NumElem <> 0) and (ListCocktail.NbElemToLoad <> 0) then
  begin
    AffInfoBar(InfoPourcentage(NumElem, ListCocktail.NbElemToLoad)+' '+str);
  end
  else
    AffInfoBar(str);
  if (Assigned (FSplash)) then
  begin
    FSplash.Info.Caption := str;
    FSplash.Refresh;
    if (NumElem <> 0) and (ListCocktail.NbElemToLoad <> 0) then
    begin
      FSplash.SetProgress(trunc((numElem * 100) div ListCocktail.NbElemToLoad));
    end;
  end;
  StatusBar.Refresh;
end;

procedure TFMain.AffInfoBar(const str : string);
begin
  StatusBar.SimpleText := str;
end;

procedure TFMain.LoadCocktailList;
var
  ini : TIniFile;
  filename : string;
begin
  ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
  if (paramstr(1) = '') then
    filename := ini.ReadString(INI_SECTION_GENERAL, INI_AUTOLOAD, '') // chargement de la liste par dfaut
  else
    filename := paramstr(1); // chargement de la liste passe en parametre
  OutputDebug('Chargement de '+Filename);
  if (fileName <> '') then
  begin
    if (FileExists(FileName) = false) then
      FileName := PATHTOEXE + FileName;
    if (ListCocktail.LoadFromFile(filename) <> -1) then
    begin
      AffInfo(INFO_END_OF_LOAD + Format(' (%d cocktails)', [ListCocktail.Count]), 0);
      sdCocktail.FileName := Filename;
      odCocktail.FileName := FileNAme;
    end
    else
    begin
      Listcocktail.DeleteAllRecette; // Erreur de chargement
    end;
  end;
  ListCocktail.TemplateHTML := ini.ReadString('TEMPLATE', 'html', '');
  ListCocktail.TemplateRTF  := ini.ReadString('TEMPLATE', 'rtf', '');
  ini.Free;
//  sbCocktail.SetFocus;
end;
procedure TFMain.bSearchClick(Sender: TObject);
begin
  if not assigned(FCocktailSearch) then
  begin
    FCocktailSearch := TFCocktailSearch.Create(self);
  end;
  FCocktailSearch.Show;
  EnableToolBar(false);
end;

procedure TFMain.Exporterlarecette1Click(Sender: TObject);
var
  ext : string;
begin
  sdExport.Title := Format(DIALOG_EXPORT, [eCocktailName.Text]);
  sdExport.FileName := FileNameToValidFileName(eCocktailName.Text);
  if (sdExport.Execute = true) then
  begin
    ext := UpperCase(ExtractFileExt(sdExport.Filename));
    if (ext = '.TXT') or (ext = '') then
      ListCocktail.ExportOneRecette(sdExport.FileName, Index)
    else if (ext = '.HTM') or (ext = '.HTML') then // 11/01/2001
      ListCocktail.ExportOneRecetteAsHTML(sdExport.FileName, Index)
    else if (ext = '.DOC') or (ext = '.RTF') then  // 11/01/2001
      ListCocktail.ExportOneRecetteAsRTF(sdExport.FileName, Index)
    ;
  end;
end;

procedure TFMain.Imprimer1Click(Sender: TObject);

begin
  try
    Screen.Cursor := crHourGlass;
    FPrint := TFPrint.Create(Self);
    FPrint.Initialize(INDEX);
    Screen.Cursor := crDefault;
    FPrint.QuickRep.Preview;
    FPrint.Free;
  except
    if (Assigned(FPrint)) then
      FPrint.Free;
    Screen.Cursor := crDefault;
  end;
end;

procedure TFMain.PutCocktailInCombo;
var
  i : integer;
begin
  cbCocktailName.Clear;
  for i := 0 to ListCocktail.Count - 1 do
  begin
    cbCocktailName.Items.AddObject(ListCocktail[i].Nom, TObject(i));
  end;
end;

procedure TFMain.cbCocktailNameClick(Sender: TObject);
var
  i : integer;
begin
  i := cbCocktailName.ItemIndex;
  if (i <> -1) then
  begin
    sbCocktail.Position := i;
    sbCocktailChange(nil);
  end;
end;

procedure TFMain.AProposde1Click(Sender: TObject);
begin
  FAboutBox := TFAboutBox.Create(Self);
  FAboutBox.ShowModal;
  FAboutBox.Free;
end;

procedure TFMain.FormResize(Sender: TObject);
begin
  sbCocktail.Width := Width - 250 - bSearch.Width - PanelNumeroCocktail.Width;
  gbRecette.Height := Height - 274;
  gbIngredients.Height := Height - 322;
end;

procedure TFMain.Nouvelleliste1Click(Sender: TObject);
var
  canmodif : boolean;
  res : integer;
begin
  if (modified =false) then
  begin
    canmodif := true;
  end
  else
  begin
    canmodif := true;
    res := Application.MessageBox(PCHAR(DIALOG_SAVE_BEFORE_NEW),
                           APP_NAME,
                           MB_YESNOCANCEL);
    case res of
      IDYES : begin
                EnregistrerlalisteSous1Click(self);
                if (Modified = False) then
                  canmodif := true
                else
                  canmodif := false;
              end;
      IDNO  : canmodif := true;
      IDCANCEL: canmodif := false;
    end;
  end;
  if (canModif) then
  begin
    bEffacerClick(nil);
    ListCocktail.DeleteAllRecette;
    sbCocktail.Max := 0;
    sbCocktail.Position := 0;
    sbCocktailChange(nil);
    EtatEdition := editNoEdit;
    PossibiliterEdition(false);
    AffInfoBar(INFO_DEL_ALLCOCK);
    sbCocktail.SetFocus;
    PutCocktailInCombo;
    sdCocktail.Filename := '';
  end;
end;
procedure TFMain.BitBtn1Click(Sender: TObject);
begin
  FProportion := TFProportion.Create(self);
  if (EtatEdition = editModif) or (EtatEdition = editAjout) then
  begin
  	FProportion.ShowProportion(mIngredients.Text);
  end
  else
	  FProportion.ShowProportion(ListCocktail[index].Ingredients);
  FProportion.ShowModal;
  FProportion.Free;
end;

procedure TFMain.Mlangerdeuxliste1Click(Sender: TObject);
begin
  FTools := TFTools.CReate(self);
  FTools.PageControl.ActivePage :=  FTools.TabMerge;
  FTools.ShowModal;
  FTools.Free;
end;

procedure TFMain.Nettoyeruneliste1Click(Sender: TObject);
begin
  FTools := TFTools.CReate(self);
  FTools.PageControl.ActivePage :=  FTools.TabClean;
  FTools.ShowModal;
  FTools.Free;
end;

procedure TFMain.cbMelangeurDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  Bitmap: TBitmap;
  bmpWidth: Integer;
begin
  with TComboBox(Control).Canvas do
  begin
    FillRect(Rect);
    bmpWidth  := 32;
    Bitmap := TBitmap(TComboBox(Control).Items.Objects[Index]);
    if Bitmap <> nil then
    begin
      bmpWidth := Bitmap.Width;
      if (not (odSelected in State)) then
        BrushCopy(Bounds(Rect.Left + 2,
                 (Rect.Top + Rect.Bottom - Bitmap.Height) div 2,
                 Bitmap.Width, Bitmap.Height),
                 Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height),
                 Bitmap.Canvas.Pixels[0, Bitmap.Height - 1])
      else
      begin
        BrushCopy(Bounds(Rect.Left + 2,
                 (Rect.Top + Rect.Bottom - Bitmap.Height) div 2,
                 Bitmap.Width, Bitmap.Height),
                 Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height),
                 -1)
      end;
    end;
     { uses DrawText instead of TextOut in order to get clipping against
       the combo box button   }
    Rect.Left := Rect.Left + bmpWidth + 6;
    DrawText(Handle, PChar(TComboBox(Control).Items[Index]), -1, Rect,
             DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
  end;
end;

procedure TFMain.Association1Click(Sender: TObject);
begin
  FTools := TFTools.CReate(self);
  FTools.PageControl.ActivePage :=  FTools.TabAssoc;
  FTools.ShowModal;
  FTools.Free;
end;

procedure TFMain.Copierrecettedanslepressepapier1Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PCHAR(ListCocktail.RecetteAsString[index]));
  AffInfoBar('Recette copie dans le presse-papier.');
end;

procedure TFMain.Enregistrerlaliste1Click(Sender: TObject);
begin
  if (FileExists(sdCocktail.FileName)) then
  begin
    try
      Screen.Cursor := crHourGlass;
      ListCocktail.SaveToFile(sdCocktail.FileName);
      AffInfo(INFO_END_OF_SAVE + ' ' + ExtractFileName(sdCocktail.FileName), 0);
      Modified := false;
    finally
      Screen.Cursor := crDefault;
    end;
  end
  else
  begin
    Enregistrerlalistesous1Click(Self);
  end;
end;

procedure TFMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  res : integer;
begin
  canclose := false;
  if (Modified) then
  begin
    res := Application.MessageBox(PCHAR(DIALOG_SAVE_BEFORE_QUIT),
                           APP_NAME,
                           MB_YESNOCANCEL);
    case res of
      IDYES : begin
                Enregistrerlaliste1Click(self);
                if (Modified = False) then
                  canclose := true;
              end;
      IDNO  : canclose := true;
      IDCANCEL:
    end;

  end
  else
    canclose := true;
end;

procedure TFMain.Aide2Click(Sender: TObject);
begin
  HelpOpen(FMain.Handle,ExtractFilePath(paramstr(0))+'help\cocktail.chm');
  BringToFront;
end;

procedure TFMain.OnAppException(Sender: TObject; E: Exception);
begin
  Application.MessageBox(PCHAR('Flicitations !'#10#13#10#13'Vous venez de trouver un bug.'#10#13#10#13+E.Message+#10#13#10#13+
                         'Vous pouvez envoyer ce bug  '+INFO_MAILTO+#10#13'en expliquant si possible comment cela est arriv'+
                         #10#13+APP_VERSION),
                         'Oups, i did it again...',
                         MB_ICONSTOP);
end;

procedure TFMain.cbCocktailNameKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = #13) then
  begin
    key := #0;
    cbCocktailNameClick(Sender);
  end;
end;

procedure TFMain.cbCocktailName_OnItemMatch(Sender: TObject;
  ItemIndex: Integer);
begin
  cbCocktailNameClick(Sender);
end;

procedure TFMain.Copierlaphotodanslepressepapier1Click(Sender: TObject);
begin
  if (ImageCocktail.Picture.Graphic <> nil) then Clipboard.Assign(ImageCocktail.Picture);
end;

procedure TFMain.cbCocktailNameDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  Beep;
end;

procedure TFMain.FormatText1Click(Sender: TObject);
var
  path : string;
  i : integer;
  filename : string;
  T : DWORD;
begin
  path := BrowseForPath(Handle, 'Dans quel dossier voulez vous exporter les recettes ?');
  if (path <> '') then
  begin
    Screen.Cursor := crHourGlass;
    try
      OutputDebug('Export vers '+path);
      AffInfoBar(path);
      T := GetTickCount;
      for i := 0 to ListCocktail.Count - 1 do
      begin
        filename := path+'\'+FileNameToValidFileName(ListCocktail[i].Nom);
        if (TMenuItem(Sender).Tag = 1) then
          ListCocktail.ExportOneRecette(filename+'.TXT', i)
        else if (TMenuItem(Sender).Tag = 2) then
          ListCocktail.ExportOneRecetteAsHTML(filename+'.html', i)
        else if (TMenuItem(Sender).Tag = 3) then
          ListCocktail.ExportOneRecetteAsRTF(filename+'.rtf', i);
        OutputDebug(filename);
        if (GetTickCount - T > 500) then
        begin // Toute les 500ms, on affiche le status (en pourcentage)
          T := GetTickCount;
          AffInfoBar(INFO_PLEASE_WAIT+' '+InfoPourcentage(i, ListCocktail.Count - 1));
          Application.ProcessMessages;
        end;
      end;
    except
      ShowMessage('Un problme est survenu pendant l''exportation...'#10#13'Verifier la prsence des fichiers TEMPLATE');
    end;
    Screen.Cursor := crDefault;
    AffInfoBar(INFO_END_OF_EXPORT);
  end;
end;

procedure TFMain.AidesurleWeb1Click(Sender: TObject);
begin
//  HelpOpen('http://www.cocktail.com/aide/');
end;

procedure TFMain.MisejoursurleWeb1Click(Sender: TObject);
begin
  HelpOpen(0,'http://membres.lycos.fr/wincocktail/miseajour.html');
end;

procedure TFMain.AffAlertWindow(const str : string);
begin
   OutputDebug('Alert : '+str);
   Application.MessageBox(PCHAR(str), APP_NAME, MB_OK);
end;


end.
