unit F_Tools;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls,
  F_Main;

type
  TFTools = class(TForm)
    PageControl: TPageControl;
    TabMerge: TTabSheet;
    od1: TOpenDialog;
    od2: TOpenDialog;
    GroupBox1: TGroupBox;
    eFile2: TEdit;
    Label2: TLabel;
    eFile1: TEdit;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    eDest: TEdit;
    BitBtn3: TBitBtn;
    sd: TSaveDialog;
    bMerge: TBitBtn;
    Out: TMemo;
    TabClean: TTabSheet;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    eCleanIn: TEdit;
    Label5: TLabel;
    eCleanOut: TEdit;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    bClean: TBitBtn;
    Label6: TLabel;
    GroupBox4: TGroupBox;
    bCleanActuel: TBitBtn;
    Memo1: TMemo;
    TabAssoc: TTabSheet;
    GroupBox5: TGroupBox;
    Label7: TLabel;
    eExtension: TEdit;
    Label8: TLabel;
    eProg: TEdit;
    bAssoc: TBitBtn;
    bDeAssoc: TBitBtn;
    Memo2: TMemo;
    BitBtn4: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure bMergeClick(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure bCleanClick(Sender: TObject);
    procedure bCleanActuelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bAssocClick(Sender: TObject);
    procedure bDeAssocClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure ShowInfo(const info : string);
  public
    { Dclarations publiques }
  end;

var
  FTools: TFTools;

implementation

{$R *.DFM}
uses
  IniFiles,
  U_Cocktail,
  C_Cocktail,
  U_CocktailConst,
  U_FuncReg,
  U_FuncFile;

procedure TFTools.ShowInfo(const info : string);
begin
  Out.Lines.Add(info);
  Out.Refresh;
end;

procedure TFTools.BitBtn1Click(Sender: TObject);
begin
  if (od1.Execute) then
    eFile1.Text := od1.FileNAme;
end;

procedure TFTools.BitBtn2Click(Sender: TObject);
begin
  if (od2.Execute) then
    eFile2.Text := od2.FileNAme;

end;

procedure TFTools.BitBtn3Click(Sender: TObject);
begin
  if (sd.Execute) then
    eDest.Text := sd.FileName;
end;

procedure TFTools.bMergeClick(Sender: TObject);
var
  Cock1, Cock2 : TListCocktail;
  i,j : integer;
  pCock : PTCocktailRecette;
  doublon : boolean;
  n1, n2 : string;
  nbAdd : integer;
begin
  if (eFile1.Text = '') or (eFile1.Text = '') or (eDest.Text = '') then
  begin
    ShowMessage('Veuillez saisir les chemins des fichiers');
    exit;
  end;
  nbAdd := 0;
  try
  Screen.Cursor := crHourGlass;
    Cock1 := TListCocktail.Create;
    Cock2 := TListCocktail.Create;

    ShowInfo('Chargement fichier 1');
    Cock1.LoadFromFile(eFile1.Text);
    ShowInfo(Format('Fichier 1 : %d recettes', [Cock1.Count]));

    ShowInfo('');
    ShowInfo('Chargement fichier 2');
    Cock2.LoadFromFile(eFile2.Text);
    ShowInfo(Format('Fichier 2 : %d recettes', [Cock2.Count]));

    ShowInfo('');
    ShowInfo('Mlange en cours...');
    // cock1 := cock1 + cock2
    ShowInfo('En double :');
    for i := 0 to Cock2.Count - 1 do
    begin
      n2 := Cock2[i].Nom;
      doublon := false;
      for j := 0 to Cock1.Count - 1 do
      begin
        n1 := Cock1[j].Nom;
        if (n1 = n2) then
        begin
          doublon := true;
          break;
        end;
      end;
      if (doublon = false) then
      begin
        new(pCock);
        InitPCocktailRecette(pcock);
        CopyRecette(cock2[i], pCock^);
        cock1.AddRecette(pCock);
        inc(nbAdd);
      end
      else
      begin
        ShowInfo(Format(' %s', [n1]));
      end;
    end;
    ShowInfo(Format('%d ajout(s)', [nbAdd]));
    Cock1.SaveToFile(eDest.Text);
    ShowInfo(Format('Fichier destination : %d recettes', [Cock1.Count]));
    Cock1.Free;
    ShowInfo('Fin');
    Screen.Cursor := crDefault;
  except
    Screen.Cursor := crDefault;
  end;
end;

procedure TFTools.BitBtn5Click(Sender: TObject);
begin
  if (od1.Execute) then
  begin
    eCleanIn.Text := od1.Filename;
    sd.FileName := od1.Filename;
  end;
end;

procedure TFTools.BitBtn6Click(Sender: TObject);
begin
  if (sd.Execute) then
    eCleanOut.Text := sd.Filename;
end;

procedure TFTools.bCleanClick(Sender: TObject);
var
  list : TListCocktail;
begin
  if not (FileExists(eCleanIn.Text)) or (eCleanOut.Text = '') then
  begin
    ShowMessage('Spcifier un fichier d''entre et de sortie');
    exit;
  end;
  Screen.Cursor := crHourGlass;
  List := TListCocktail.Create;
    List.LoadFromFile(eCleanIn.Text);
    List.Clean;
    List.SaveToFile(eCleanOut.Text);
  List.Free;
  Screen.Cursor := crDefault;
  ShowMessage(DIALOG_CLEANOK);
end;

procedure TFTools.bCleanActuelClick(Sender: TObject);
var
  ini : TIniFile;
  photopath : string;
  videopath : string;
begin
  ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
  photopath := ini.ReadString(INI_PATH_SECTION, INI_PATH_PHOTO, '');
  videopath := ini.ReadString(INI_PATH_SECTION, INI_PATH_VIDEO, '');
  AppendSlashToPath(PhotoPath);
  AppendSlashToPath(VideoPath);
  ini.Free;

  Screen.Cursor := crHourGlass;
    FMain.ListCocktail.CleanWithPath(VideoPath, PhotoPath);
    FMain.sbCocktailChange(nil);
    FMain.Modified := true;
  Screen.Cursor := crDefault;
  ShowMessage(DIALOG_CLEANOK);
end;

procedure TFTools.FormCreate(Sender: TObject);
begin
  eProg.Text := Paramstr(0);
end;

procedure TFTools.bAssocClick(Sender: TObject);
var
  ext : string;
begin
  ext := eExtension.Text;
  if (ext <> '') then
  begin
    if (ext[1] = '.') then
    begin
      ext := Copy(ext, 2, length(ext));
      eExtension.Text := ext;
    end;
    associe(ext, eProg.Text, '');
    ShowMessage('Fichiers associs');
  end;
end;

procedure TFTools.bDeAssocClick(Sender: TObject);
var
  ext : string;
begin
  ext := eExtension.Text;
  if (ext <> '') then
  begin
    if (ext[1] = '.') then
    begin
      ext := Copy(ext, 2, length(ext));
      eExtension.Text := ext;
    end;
    retireassociation(ext);
    ShowMessage('Association enlever');
  end;
end;

end.
