unit U_FuncDialog;
{** U_FuncDialog.pas
 ** __JF 22/03/2001
 ** Unit for manipulating dialog and message box functions
 **}

interface
uses
  Windows;
function BrowseForComputer(const winhandle : THANDLE; const title : string) : string; //affiche une boite de dialogue pour slectionner un ordinateur  public
// Popup the Browse for computer dialgo

function BrowseForPath(const Handle : THandle; const Title : String) : string;
// Popup the Browse for path dialog

implementation
uses
  shlobj,
  SysUtils;
function BrowseForComputer(const winhandle : THANDLE; const title : string) : string; //affiche une boite de dialogue pour slectionner un ordinateur  public
var
  BrowseInfo: TBrowseInfo;
  IDRoot: PItemIDList;
  Path: array[0..MAX_PATH] of Char;
begin
  // Get the Item ID for Network Neighborhood
  SHGetSpecialFolderLocation(winHandle, CSIDL_NETWORK, IDRoot);
  ZeroMemory(@BrowseInfo, SizeOf(TBrowseInfo));
  ZeroMemory(@path, MAX_PATH);
  BrowseInfo.hwndOwner := winhandle;
  BrowseInfo.pidlRoot := IDRoot;
  BrowseInfo.lpszTitle := PChar(title);
  BrowseInfo.pszDisplayName := @path;
  // Include this flag to show computer only
  BrowseInfo.ulFlags := BIF_BROWSEFORCOMPUTER;// or BIF_RETURNONLYFSDIRS   ;
  // Show the browse dialog, get the Item ID for the selected item and convert it to a path
  SHBrowseForFolder(BrowseInfo);
//  SHGetPathFromIDList(IDList, Path);
  result := path;
end;

function BrowseForPath(const Handle : THandle; const Title : String) : string;
var
  BrowseInfo : TBrowseInfo;
  RetBuffer,
  ResultBuffer : Array[0..255] of char;
  PIDL : PItemIDList;
begin

  //Initialize buffers
  FillChar(BrowseInfo,SizeOf(TBrowseInfo),#0);
  Fillchar(RetBuffer,SizeOf(RetBuffer),#0);
  FillChar(ResultBuffer,SizeOf(ResultBuffer),#0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.pszDisplayName := @Retbuffer;
  BrowseInfo.lpszTitle := @Title[1];

  // we want a status-text
  BrowseInfo.ulFlags := BIF_StatusText;

  // Our call-back function cheching for fileexist
  BrowseInfo.lpfn := nil; //@BrowseCallBack;

  // Show BrowseForDlg
  PIDL := SHBrowseForFolder(BrowseInfo);

  // Return fullpath to file
  if SHGetPathFromIDList(PIDL,ResultBuffer) then
    result := StrPas(ResultBuffer)
  else
    Result := '';
  GlobalFreePtr(PIDL);  //Clean up
end;

end.
