unit U_FlatButton;

interface

uses
  Controls, StdCtrls, Forms, Windows, buttons;

procedure FlattenAllButtons;
procedure Flatten(theControl: TWinControl);

implementation

procedure Flatten(theControl: TWinControl);
var
   dwStyle: Longint;
begin
     dwStyle := GetWindowLong(theControl.handle, GWL_STYLE) or BS_FLAT;
     SetWindowLong(theControl.Handle, GWL_STYLE, dwStyle);
end;

procedure FlattenAllButtons;
var
  i,j : integer;
begin
  for i := 0 to Application.ComponentCount - 1 do
  begin
    if (Application.Components[i] is TForm) then
    begin
      for j := 0 to TForm(Application.Components[i]).ComponentCount - 1 do
      begin
        if (TForm(Application.Components[i]).Components[j] is TButton) then
          Flatten(TButton(TForm(Application.Components[i]).Components[j]))
        else if (TForm(Application.Components[i]).Components[j] is TBitBtn) then
          Flatten(TBitBtn(TForm(Application.Components[i]).Components[j]))
        else if (TForm(Application.Components[i]).Components[j] is TCheckBox) then
          Flatten(TCheckBox(TForm(Application.Components[i]).Components[j]))
        else if (TForm(Application.Components[i]).Components[j] is TRadioButton) then
          Flatten(TRadioButton(TForm(Application.Components[i]).Components[j]))
        ;

      end;
    end;
  end;
end;

end.
