;** Fichier de configuration de l'installation / dsinstallation
;** de WinCocktail.exe . Construit avec Nullsoft SuperPIMP Install System (NSIS) v1.1j
;** http://www.nullsoft.com/free/nsis/
;**
;** Attention : rechercher tout les c:\language\delphi3\_myprog\Cocktail\
;** et remplacer les par le rpertoire de base o
;** se trouvent les sources de WinCocktail.

Name "WinCocktail"
OutFile wcock.exe
CRCCheck on
LicenseText "Veuillez lire attentivement ce qui suit..."
LicenseData c:\language\delphi3\_myprog\Cocktail\readme.txt
InstallDir $PROGRAMFILES\WinCocktail

ComponentText "Que voulez-vous installer ?"
InstType Normal
DirText "O voulez vous m'installer ?"
EnabledBitmap "d:\perso\inst_en.bmp"
DisabledBitmap "d:\perso\inst_di.bmp"

UninstallText "D-installation"
UninstallExeName uninst.exe
UninstallIcon d:\perso\uninst.ico

Section "Logiciel WinCocktail"
SectionIn 1
SetOutPath $INSTDIR
SetOverwrite on
File c:\language\delphi3\_myprog\Cocktail\cocktail.exe
File c:\language\delphi3\_myprog\Cocktail\cocktail.ini
File c:\language\delphi3\_myprog\Cocktail\*.txt
SetOutPath $INSTDIR\res
; icone, bmp...
File c:\language\delphi3\_myprog\Cocktail\res\*.*
SetOutPath $INSTDIR

Section "Fichier d'aide"
SectionIn 1
SetOutPath $INSTDIR\Help
File c:\language\delphi3\_myprog\Cocktail\help\*.chm
SetOutPath $INSTDIR
WriteINIStr $INSTDIR\cocktail.ini CGI RealPath "$INSTDIR"

Section "Base de recettes"
SectionIn 1
SetOutPath $INSTDIR
File c:\language\delphi3\_myprog\Cocktail\cocktail.ctl

Section "Photos"
SectionIn 1
SetOutPath $INSTDIR\Photo
File c:\language\delphi3\_myprog\Cocktail\photo\*.*
; SetOutPath $INSTDIR\Video
; File c:\language\delphi3\_myprog\Cocktail\video\*.*

Section "Association des fichiers"
SectionIn 1
WriteRegStr HKEY_CLASSES_ROOT ".ctl" "" "CTL_File"
WriteRegStr HKEY_CLASSES_ROOT "CTL_File" "" "Fichier CTL"
WriteRegStr HKEY_CLASSES_ROOT "CTL_File\shell" "" "open"
WriteRegStr HKEY_CLASSES_ROOT "CTL_File\DefaultIcon" "" $INSTDIR\cocktail.exe,0
WriteRegStr HKEY_CLASSES_ROOT "CTL_File\shell\open\command" "" '"$INSTDIR\cocktail.exe" "%1"'


; Fin de l'install,
SetOutPath $INSTDIR

Section -post
WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCocktail" "DisplayName" "WinCocktail (Supprimer)"
WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCocktail" "UninstallString" '"$INSTDIR\uninst.exe"'

CreateShortCut "$DESKTOP\WinCocktail.lnk" "$INSTDIR\cocktail.exe" "" "" "0"

Exec '"explorer" "$INSTDIR\"'

MessageBox "MB_OK" "L'installation de WinCocktail est termin. Une icone se trouve sur le bureau" IDNO 1

Section Uninstall
DeleteRegKey HKEY_CLASSES_ROOT ".ctl"
DeleteRegKey HKEY_CLASSES_ROOT "CTL_File"
DeleteRegKey HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCocktail"
Delete $INSTDIR\help\*.*
Delete $INSTDIR\photo\*.*
Delete $INSTDIR\res\*.*
Delete $INSTDIR\*.*
RMDir $INSTDIR\Photo
RMDir $INSTDIR\res
RMDir $INSTDIR