unit F_Print;
{**
 ** V1.01D : il manquait le test pour savoir si on doit afficher la photo
 **}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, quickrpt, Qrctrls;

type
  TFPrint = class(TForm)
    QuickRep: TQuickRep;
    ColumnHeaderBand1: TQRBand;
    DetailBand1: TQRBand;
    PageFooterBand1: TQRBand;
    QRRecetteNom: TQRLabel;
    qrNbPers: TQRLabel;
    QRImageMelangeur: TQRImage;
    qrImageVerre: TQRImage;
    qrMelangeur: TQRLabel;
    qrVerre: TQRLabel;
    qrPrix: TQRLabel;
    QRShape1: TQRShape;
    qrMemoIngred: TQRMemo;
    QRShape2: TQRShape;
    qrImageCocktail: TQRImage;
    QRMemoRecette: TQRMemo;
    qrInfo: TQRLabel;
    qrAuteur: TQRLabel;
    QRSysData1: TQRSysData;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRMemo1: TQRMemo;
    QRShape3: TQRShape;
    QRShape4: TQRShape;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure Initialize(idx : integer);
  end;

var
  FPrint: TFPrint;

implementation

{$R *.DFM}
Uses
  F_Main,
  U_Cocktail, U_CocktailConst, {specif unit}
  C_Cocktail, {specif classes}
  D_Cocktail, {datamodule}
  U_FuncString, { func unit }
  F_DialogColor; {generic unit}

function PrintPluriel(n : integer) : string;
begin
  if (n>1) then
    result := 's'
  else
    result := '';
end;

procedure TFPrint.Initialize(idx : integer);
var
  pCock : pTCocktailRecette;
begin
  try
    pCock := FMain.ListCocktail.ItemsPointer[idx];
    QRRecetteNom.Caption := pCock^.Nom;
    qrNbPers.Caption := Format('Recette pour %d personne%s.', [pCock^.NbPersonne, PrintPluriel(pCock^.NbPersonne)  ]);
    qrImageMelangeur.Picture := FMain.ImageMelangeur.Picture;
    qrImageVerre.Picture := FMain.ImageVerre.Picture;
    qrMelangeur.Caption := CocktailMelangeur2Str(pCock^.Melangeur);
    qrVerre.Caption := CocktailVerre2Str(pcock^.Verre);
    qrPrix.Caption := Format('Cot : %s', [CocktailCout2Str(pcock^.Cout)]);
    qrMemoIngred.Lines.Text := pCock^.Ingredients;
    if (FMain.ImageCocktail.Visible) then // V1.01D : il manquait le test pour savoir si on doit afficher la photo
      qrImageCocktail.Picture := FMain.ImageCocktail.Picture;
    QRMemoRecette.Lines.Text := pCock^.Recette;
    qrInfo.Caption := Format('Gout : %s, Temprature : %s, Bulle : %s',
    [ CocktailGout2Str(pCock^.Gout), CocktailTemperature2Str(pCock^.Temperature),
      BooleanToStrYN(pCock^.Bulle)]);
    if (pCock^.Auteur <> '') then
      qrAuteur.Caption := Format('Auteur : %s', [pCock^.Auteur])
    else
      qrAuteur.Caption := '';

  except
    Close;
  end;
end;

end.
