unit F_ShowPicture;

interface

uses
  Windows, Messages, SysUtils, Classes, JPEG, gifimage, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, F_Main, StdCtrls, Buttons;

type
  TFShowPicture = class(TForm)
    Image1: TImage;
    bClose: TBitBtn;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure LoadPicture(pic : string);
  end;

var
  FShowPicture: TFShowPicture;

implementation

{$R *.DFM}
procedure TFShowPicture.LoadPicture(pic : string);
begin
  if (pic = '') then
  begin
    Image1.Picture := FMain.ImageCocktail.Picture;
  end
  else
  begin
    if (FileExists(pic)) then
      Image1.Picture.LoadFromFile(pic)
    else
    begin
      // rechercher a partir du repertoire spcifier dans le fichier ini
      FMain.LoadCocktailPhoto(pic, image1);
    end;
    Image1.Hint := pic;
  end;
  ClientWidth := Image1.Width;
  ClientHeight := Image1.Height  + bClose.Height + 8;
  bClose.Width := Image1.Width;
  bClose.Top := Image1.Height+8;
end;

end.
