unit U_Help;

interface
uses
  windows,
  sysutils,
  ShlObj, ShellApi,
  comobj;

procedure HelpOpen(wnd : HWND;const filename : string);
implementation
uses U_FuncDebug;
var
  IE        : Variant;
  IEHWND    : HWND;

procedure InitHelpSystem;
begin
  try
    if( VarIsEmpty(IE) )then
    begin
      IE := CreateOleObject('InternetExplorer.Application');
      IEHWND := FindWIndow('IEFrame', nil);
    end
    else
    begin
      IEHWND := FindWIndow('IEFrame', nil);
    end;
  except
  end;
end;

procedure WaitForHelpReady(timeout : integer);
var
  T : longint;
begin
  T := GetTickCount;
  repeat
    Sleep(timeout div 16);
  until ((GetTickCount - T) >= timeout) or (IE.Busy = false);
end;

procedure HelpOpen(wnd : HWND;const filename : string);
var
  res : integer;

begin
{  if not VarIsEmpty(IE) then
  begin
    IE.AddressBar := false;
    IE.MenuBar := false;
    IE.StatusBar := false;
    IE.Toolbar := false;
    IE.Visible := true;
    IE.Navigate(filename);
    WaitForHelpReady(1);
  end;}

  res := ShellExecute(wnd, nil {PCHAR('open')}, PCHAR(filename), nil, nil, SW_SHOWNORMAL);
  if (integer(res) <= 32) then
  begin
    // failed
  end
  else
  begin
    Sleep(500);
  end;

end;                         

procedure OpenIE(aURL: string);
var
  WinHanlde : HWnd;
begin
  if( VarIsEmpty(IE) )then
  begin
    IE := CreateOleObject('InternetExplorer.Application');
    IE.AddressBar := false;
    IE.MenuBar := false;
    IE.StatusBar := false;
    IE.Toolbar := false;
    IE.Visible := true;
    IE.Navigate(aURL);
  end
  else
  begin
    WinHanlde := FindWIndow('IEFrame', nil);
    if (0 <> WinHanlde) then
    begin
      IE.Navigate(aURL);
//      SetForegroundWindow(WinHanlde);
    end
    else
      // errorhandling
  end;
end;

initialization
//  InitHelpSystem;
end.
