@echo off
SET zipexe=c:\utils\pkzipC.exe
SET COCKVER=%1%
echo Ceci va crer un repertoire REDIST
echo avec dedans un repertoire SOURCES avec les sources de COCKTAIL
echo et l'executable directement dans le repertoire REDIST.
echo Un fichier ZIP contenant les sources sera creer,
echo et un programme d'installation sera creer.
pause
echo.
if var%COCKVER%==var goto :Err_param1
:Continu1
if EXIST wcock%COCKVER%.exe goto :Err_exe_exist
if EXIST wcock%COCKVER%_src.zip goto :Err_zip_exist
call _MakeExe.bat
mkdir REDIST
cd REDIST
rem del /q /s *.* > NUL
mkdir SOURCES
mkdir RES
mkdir HELP
mkdir PHOTO

cd SOURCES
mkdir help
xcopy ..\..\help\*.* .\help\ /s /e /d
xcopy ..\..\*.pas . /d
xcopy ..\..\*.dfm . /d
xcopy ..\..\Cocktail.d* . /d
xcopy ..\..\Cocktail.res . /d
xcopy ..\..\*.bmp . /d
xcopy ..\..\*.ico . /d
xcopy ..\..\*.bat . /d
xcopy ..\..\cocktail.ctl . /d
xcopy ..\..\*.ini . /d
xcopy ..\..\*.nsi /d
mkdir RES
xcopy ..\..\RES\*.* RES\ /d
mkdir UNITS
xcopy ..\..\..\units\u_func*.pas UNITS\ /d

cd ..

cd RES
xcopy ..\..\res\*.* /d
cd ..

cd help
xcopy ..\..\help\*.chm /s /e
cd ..


cd photo

xcopy ..\..\photo\*.* /s /e /d

cd ..

cd
cd REDIST

xcopy ..\Cocktail.exe . /d

xcopy ..\cocktail.ini . /d

rem copy ..\*.avi .

xcopy ..\*.txt . /d

xcopy ..\cocktail.ctl . /d
cd
Echo Creation de l'archive des sources
echo %zipexe% -add -recurse -directories ..\cocktail.zip *.*
%zipexe% -add -recurse -directories ..\wcock%COCKVER%_src.zip sources\*.* >> ..\reszip.log

Echo Compilation de l'installable
cd ..
call _compilensi.bat >> resnsi.log
ren wcock.exe wcock%COCKVER%.exe

Echo Creation du fichier de donne
%zipexe% -add wcock%COCKVER%_ctl.zip cocktail.ctl >> reszip.log

echo Compression de l'executable seul
%zipexe% -add wcock%COCKVER%_exe.zip cocktail.exe *.txt >> reszip.log

echo Compession des photos seules
%zipexe% -add wcock%COCKVER%_photos.zip redist\photo\*.* >> reszip.log

echo FINI !
pause
goto :EOF

:Err_param1
echo Passer le numero de version en parametre a ce BAT.
goto :EOF

:Err_exe_exist
echo Il existe deja un fichier wcock%COCKVER%.exe
goto :EOF

:Err_zip_exist
echo Il existe deja un fichier wcock%COCKVER%_src.zip
goto :EOF

EOF:
pause
